//
// AGC block.
// Taken from Kohlrausch92 and
// some of bedk code.
// $Header: /n/poi/da/bilmes/sp/fe/RCS/Agc_Kohlrausch.h,v 1.1 1997/03/20 06:40:06 bilmes Exp $

#ifndef AGC_H
#define AGC_H

#include "Blocker.h"
#include "Matrix.h"
#include "Vector.h"


class Agc_Kohlrausch : public Blocker {

  const size_t IOBlocking;      // max signal length we might be sent
  const float samplingFrequency;
  const size_t numChannels;

  float *gains;
  Matrix *result;

  const float a1;
  const float b0;  

  void zeroGains();

public:

  Agc_Kohlrausch(size_t IOBlocking,
		 float samplingFrequency,
		 size_t numChannels,
		 float agctau); // Time constant, time (in ms) till response is
                                // at 1/e of it's original value.


  Agc_Kohlrausch(size_t IOBlocking,
		 float samplingFrequency,
		 size_t numChannels,
		 float tau,
		 float db); // tau = time (in ms) till response is
                            // at db dB down from it's original value.
  ~Agc_Kohlrausch();

  const CMatrix processBlock(const CMatrix in,
			     bool& lastTime);

};


#endif
