. $Header: /u/drspeech/src/dr_scripts/RCS/dr_recog.man,v 1.3 1998/05/11 19:37:13 dpwe Exp $
.\" A few notes:
.\" i) Don't add extra blank lines - these appear in the output and
.\"    leaves too much space when display on the screen
.\"
.\" This title line needs to be changed to contain your program name,
.\" but the date will be changed automatically by RCS.
.TH dr_recog 1 "$Date: 1998/05/11 19:37:13 $" ICSI
.\" Don't do anything clever in the section below - it messes up the
.\" whatis database that's accessed using "man -k"
.SH NAME
dr_recog \- run recognition on a speech feature file
.SH SYNOPSIS
.B dr_recog [options]
.SH DESCRIPTION
.I dr_recog 
runs recognition on a speech feature file and scores the results

.SH ENVIRONMENT VARIABLES

The location of the
.BR drspeech(1)
and
.BR drspeech_args(1)
packages must be in your PERLLIB environment variable.

.SH FILES

.I dr_recog
minimally requires a feature file, a norm file, word transcriptions of
the utterances in the recognition set, a lexicon
file, a priors file, and an MLP weights file as input.  It produces a
recognition results file and a recognition score file as output.

.SH FILENAME TEMPLATES AND ESCAPES
.I dr_recog
uses a template mechanism to provide user control over the naming of
the results and score files.  A template is a string of regular
characters and escapes characters that
.I dr_embed
expands to form a filename.

There are two escapes:

%j expands to the value of the ``job'' command-line parameter.

%% expands to %

While all of the default filename templates expand to files that are in
the current directory, it is possible to specify templates that point to
other directories.  Thus, if you wanted to write the recognition scores
from your embedded training into a directory named ``scores'' that is
below the current directory, you could set
.if n .ti +0    \" Useful way of moving on to the next line
scores_filename_template=./scores/%j.score
.if n .ti +0    \" Useful way of moving on to the next line

.SH OPTIONS
.TP 1i			\" Indent the paragraph
.B help=<any> (optional) [no default]
Print a usage message, then exit without doing any computation.
.TP
.B verbose=<integer> (optional) [default=1]
Set verbosity level for script.  verbose=0 means produce no logging
output.
.TP
.B logname=<filename> (optional) [default=-]
Log file for embedded training.
.TP
.B params=<filename> (optional) [no default]
Name of parameter file to read.  The file is ASCII, with one
<arg>=<value> pair per line.
.TP
.B job=<filename> (required)
Name that uniquely identifies the embedded training job.  This string is
substituted for the %j escape.
.TP
.B ftr_start=<cardinal> (required)
First feature to use during MLP forward pass.  Features are numbered from 0.
.TP
.B ftr_count=<cardinal> (required)
Number of features to use during MLP forward pass.
.TP
.B recog_ftr_file=<filename> (required)
Feature file to do recognition on.  Currently this file must be in
.BR pfile(5)
format.
.TP
.B recog_sent_start=<cardinal> (required)
First utterance to use in recognition.  Utterances are numbered from 0.
.TP
.B recog_sent_count=<cardinal> (required)
Number of sentences to use in recognition.
.TP
.B recog_norm_file=<filename> (required)
Norm file for recognition data.  In
.BR norms(5)
format.
.TP
.B recog_sents=<filename> (required)
Word transcriptions of utterances in the recognition set.
.TP
.B lexicon=<filename> (required)
Lexicon of word models for recognition.  Currently this file must be in
.BR lexicon(5)
format.
.TP
.B recog_priors=<filename> (required)
Priors used for recognition.  In
.BR priors(5)
format.
.TP
.B recog_weights=<filename> (required)
MLP weights used for recognition.  In
.BR weights(5)
format.
.TP
.B mlp3_input_size=<cardinal> (required)
Size of MLP input layer.
.TP
.B mlp3_hidden_size=<cardinal> (required)
Size of MLP hidden layer.
.TP
.B mlp3_output_size=<cardinal> (required)
Size of MLP output layer.
.TP
.B window_extent=<cardinal> (required)
Size of the union of all windows on the input features.
.TP
.B future_context=<cardinal> (required)
Number of frames of future context in the MLP input window.
.TP
.B past_context=<cardinal> (required)
Number of frames of past context in the MLP input window.
.TP
.B ftr_window_offset=<cardinal> (required)
Offset in frames on MLP input window.
.TP
.B phoneset=<filename> (optional) [default=]
Phoneset used to label the recognition data.  In
.BR phoneset(5)
format.  This used to be a required parameter, but is not 
in fact used during recognition, so it is now tolerated 
as an optional parameter, but ignored.
.TP
.B bigram=<opt_filename> (optional) [default=]
Bigram grammar to use during recognition.  If this option is used, the
wpbegin, wpcont, or wpend options cannot be used.  File currently must
be in
.BR bigram(5)
format.
.TP
.B wpbegin=<opt_filename> (optional) [default=]
Word-pair grammar begin file to use during recognition.  If this option
is used, the wpcont and wpend options must also be used, and the bigram
option cannot be used.
.TP
.B wpcont=<opt_filename> (optional) [default=]
Word-pair grammar middle file to use during recognition.  If this
option is used, the wpbegin and wpend options must also be used, and the
bigram option cannot be used.
.TP
.B wpend=<opt_filename> (optional) [default=]
Word-pair grammar end file to use during recognition.  If this option is
used, the wpbegin and wpend options must also be used, and the bigram
option cannot be used.
.TP
.B mlp3_output_type=<label> (optional) [default=softmax]
MLP output unit type.
.TP
.B mlp3_fx=<boolean> (optional) [default=true]
Use fixed-point in MLP evaluation.  If this is false, use_spert should
probably also be false.
.TP
.B use_spert=<boolean> (optional) [default=true]
Run MLP training and forward passes on a SPERT board.  If this is false,
mlp3_fx should probably also be false.
.B recog_lmscale=<float> (optional) [default=1]
Language scaling factor to use during recognition.
.TP
.B recog_amscale=<float> (optional) [default=1]
Acoustic scaling factor to use during recognition.
.TP
.B recog_ptscale=<float> (optional) [default=1]
Phone transition scaling factor to use during recognition.
.TP
.B recog_wordtranspenalty=<float> (optional) [default=1]
Word transition penalty to use during recognition.
.TP
.B recog_maxactivewords=<cardinal> (optional) [default=30]
Maximum nuber of active words during recognition.
.TP
.B recog_startpruningframe=<integer> (optional) [default=-1]
Frame to start pruning during recognition.
.TP
.B recog_transcut=<float> (optional) [default=0]
Word transition pruning during recognition.
.TP
.B recog_beamwidth=<float> (optional) [default=120]
Search beam width during recognition.
.TP
.B recog_phoneprune=<float> (optional) [default=-1]
Phone pruning during recognition.
.TP
.B results_filename_template=<any> (optional)
.in 0.5i
.B [default=%j.results]
.in 1.5i
Template for names of result files generated during recognition.
.TP
.B scores_filename_template=<any> (optional) [default=%j.score]
Template for names of score files generated during recognition.
.B activation_format=<label> (optional) [default=rapbin]
Format of activations from forward passes.
.TP
.B spertrun_prog=<opt_filename> (optional) [default=spertrun]
Program to execute SPERT programs.
.TP
.B spertrun_args=<any> (optional) [default=]
Optional arguments to SPERT program executor.
.TP
.B swbforward_prog=<filename> (optional) [default=swbforward]
Program to do forward pass on MLP.
.TP
.B swbforward_args=<any> (optional) [default=]
Optional arguments to MLP forward pass program.
.TP
.B wordscore_prog=<filename> (optional) [default=wordscore]
Program for scoring recognition output.
.TP
.B wordscore_args=<any> (optional) [default=]
Optional arguments to recognition scoring program.
.TP
.B y0_recog_prog=<filename> (optional) [default=y0]
Speech decoding program.
.TP
.B y0_recog_args=<any> (optional) [default=]
Optional arguments to speech decoder.

.SH SAMPLE PARAMETER FILE

Here is a sample parameter file for an MLP with the usual 9-frame
context window that is centered on the current frame.  This is given for
illustrative purposes only.  Don't count on any of the files actually
existing.

.nf
job=plp_baseline+devtest+reverb
logname=plp_baseline+devtest+reverb.dr_recog_log
recog_ftr_file=../../pfile/numbers93+devtest+reverb+plp8+w25s12_5+F.pfile
recog_norm_file=../../pfile/numbers93+train+plp8+w25s12_5+F.norm
ftr_start=1
ftr_count=8
window_extent=9
ftr_window_offset=0
past_context=4
future_context=4
recog_priors=../../pfile/numbers93+train+icsi56+w25s12_5+alignable.priors
recog_weights=../../wts/numbers93+train+plp8+w25s12_5+icsi56+alignable.wts
mlp3_input_size=72
mlp3_hidden_size=512
mlp3_output_size=56
lexicon=../../lex/numbers93.lex
bigram=/u/lingling/NUMBER/grammar/classbigramLogi+bigram
recog_wordtranspenalty=0.1
recog_lmscale=8
recog_sents=../../wordtrans/num93+devtest.answer
phoneset=/u/drspeech/data/phonesets/icsi56.phset
recog_sent_start=0
recog_sent_count=657
.fi

.SH AUTHOR
Brian Kingsbury <bedk@icsi.berkeley.edu>
.SH SEE ALSO
.BR drspeech(1), drspeech_args(1), spertrun(1), swbforward(1),
.BR wordscore(1), y0(1), bigram(5), lexicon(5), norms(5), pfile(5),
.BR phoneset(5), priors(5), weights(5)
