/* Code generated by ./gen_mul_vfmf_vf */
/* Version: $Header: /u/spert/src/fltvec/php/RCS/mul_vfmf_vf.c,v 1.4 1995/10/13 00:13:43 davidj Exp $ */
/* n_cols=8 rec2flag=8 */

#include <fltv-config.h>
#include <stddef.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

#ifdef DECL_php_mul_vfmf_vf
void php_mul_vfmf_vf(const size_t rows, const size_t cols,
		     const float* vec, const float* mat, float* res);
#endif

#ifdef DECL_php_mul_vdmd_vd
void php_mul_vdmd_vd(const size_t rows, const size_t cols,
		     const double* vec, const double* mat, double* res);
#endif


#ifdef DEFN_php_mul_vfmf_vf
#define FP_TYPE float
#define ROUT_NAME php_mul_vfmf_vf
#endif

#ifdef DEFN_php_mul_mdvd_vd
#define FP_TYPE double
#define ROUT_NAME php_mul_mdvd_vd
#endif

#define CB (8)

void
ROUT_NAME(const size_t rows, const size_t cols,
          const FP_TYPE* vec, const FP_TYPE* mat, FP_TYPE* res)
{
    const FP_TYPE* end_inp = vec + rows;
    size_t i = 0;

    size_t last_b8_col;
    last_b8_col = cols & ~(7);
    for ( ; i != last_b8_col; i += 8)
    {
        const FP_TYPE* inp = vec;
        const FP_TYPE* colp = mat;

        FP_TYPE csum0 = 0.0;
        FP_TYPE csum1 = 0.0;
        FP_TYPE csum2 = 0.0;
        FP_TYPE csum3 = 0.0;
        FP_TYPE csum4 = 0.0;
        FP_TYPE csum5 = 0.0;
        FP_TYPE csum6 = 0.0;
        FP_TYPE csum7 = 0.0;

        while (inp != end_inp)
        {
            const FP_TYPE velem = *inp++;

            csum0 += velem * colp[0];
            csum1 += velem * colp[1];
            csum2 += velem * colp[2];
            csum3 += velem * colp[3];
            csum4 += velem * colp[4];
            csum5 += velem * colp[5];
            csum6 += velem * colp[6];
            csum7 += velem * colp[7];

            colp += cols;
        }
        res[0] = csum0;
        res[1] = csum1;
        res[2] = csum2;
        res[3] = csum3;
        res[4] = csum4;
        res[5] = csum5;
        res[6] = csum6;
        res[7] = csum7;

        res += 8;

        mat += 8;
    }

    if (cols & 4)
    {
        const FP_TYPE* inp = vec;
        const FP_TYPE* colp = mat;

        FP_TYPE csum0 = 0.0;
        FP_TYPE csum1 = 0.0;
        FP_TYPE csum2 = 0.0;
        FP_TYPE csum3 = 0.0;

        while (inp != end_inp)
        {
            const FP_TYPE velem = *inp++;

            csum0 += velem * colp[0];
            csum1 += velem * colp[1];
            csum2 += velem * colp[2];
            csum3 += velem * colp[3];

            colp += cols;
        }
        res[0] = csum0;
        res[1] = csum1;
        res[2] = csum2;
        res[3] = csum3;

        res += 4;

        mat += 4;
    }

    if (cols & 2)
    {
        const FP_TYPE* inp = vec;
        const FP_TYPE* colp = mat;

        FP_TYPE csum0 = 0.0;
        FP_TYPE csum1 = 0.0;

        while (inp != end_inp)
        {
            const FP_TYPE velem = *inp++;

            csum0 += velem * colp[0];
            csum1 += velem * colp[1];

            colp += cols;
        }
        res[0] = csum0;
        res[1] = csum1;

        res += 2;

        mat += 2;
    }

    if (cols & 1)
    {
        const FP_TYPE* inp = vec;
        const FP_TYPE* colp = mat;

        FP_TYPE csum0 = 0.0;

        while (inp != end_inp)
        {
            const FP_TYPE velem = *inp++;

            csum0 += velem * colp[0];

            colp += cols;
        }
        res[0] = csum0;

        res += 1;

        mat += 1;
    }

}
