/*
** $Header: /u/spert/src/fltvec/wrp/RCS/vecele.c,v 1.4 1996/04/04 01:13:27 davidj Exp $
**
** Element wise vector routines - Wrapper versions
*/

#include <fltv-config.h>
#include <assert.h>
#include <stddef.h>
#include <stdio.h>
#ifdef FLTV_HAVE_LIBINTVEC
#include "intvec.h"
#endif
#include <fltv-defs.h>
#include <fltv-scansrc.h>

/****************************************************************/
/* acc_vf_vf implemented using add_vfvf_vf                       */
/****************************************************************/

#ifdef DECL_wrp_acc_vf_vf
void wrp_acc_vf_vf(size_t len, const float* from, float* to);
#endif

#ifdef DEFN_wrp_acc_vf_vf
void
wrp_acc_vf_vf(size_t len, const float* from, float* to)
{
    add_vfvf_vf(len, from, to, to);
}

#endif


/****************************************************************/
/* Endian swapping routines - big to host for float vectors */
/****************************************************************/

#ifdef DECL_wrp_btoh_vf_vf
void wrp_btoh_vf_vf(size_t len, const float* from, float* to);
#endif

#ifdef DEFN_wrp_btoh_vf_vf

/* Declaration for the function if the library is not present */
#ifndef FLTV_HAVE_LIBINTVEC
extern void btoh_vi32_vi32(size_t, const fltv_int32_t* from, fltv_int32_t* to);
typedef fltv_int32_t intv_int32_t ;
#endif

void
wrp_btoh_vf_vf(size_t len, const float* from, float* to)
{
    btoh_vi32_vi32(len, (const intv_int32_t*) from, (intv_int32_t*) to);
}
#endif

/****************************************************************/
/* Endian swapping routines - host to big for float vectors */
/****************************************************************/

#ifdef DECL_wrp_htob_vf_vf
void wrp_htob_vf_vf(size_t len, const float* from, float* to);
#endif

#ifdef DEFN_wrp_htob_vf_vf

/* Declaration for the function if the library is not present */
#ifndef FLTV_HAVE_LIBINTVEC
extern void htob_vi32_vi32(size_t, const fltv_int32_t* from, fltv_int32_t* to);
typedef fltv_int32_t intv_int32_t ;
#endif

void
wrp_htob_vf_vf(size_t len, const float* from, float* to)
{
    htob_vi32_vi32(len, (const intv_int32_t*) from, (intv_int32_t*) to);
}
#endif
