/*
** $Header: /u/spert/src/intvec/nv/RCS/mat.c,v 1.3 1996/10/23 00:50:17 davidj Exp $
**
** Integer matrix operations
*/

#include <intv-config.h>
#include <stddef.h>
#include <intv-defs.h>
#include <intv-scansrc.h>

/* Matrix transpose. */

#ifdef DECL_nv_trans_mi16_mi16
void nv_trans_mi16_mi16(size_t in_height, size_t in_width,
			size_t in_lda, size_t res_lda,
			const intv_int16_t* in, intv_int16_t* res);
#endif

#ifdef DEFN_nv_trans_mi16_mi16
void
nv_trans_mi16_mi16(size_t in_height, size_t in_width,
		   size_t in_lda, size_t res_lda,
		   const intv_int16_t* in, intv_int16_t* res)
{
    size_t i, j;
    const intv_int16_t *from;	/* Get elements from here. */
    intv_int16_t *to;		/* Put elements here. */
    const intv_int16_t *fromcol; /* Current column in input. */
    intv_int16_t *torow;	/* Current row in result. */

    fromcol = in;
    torow = res;
    for (i=0; i<in_width; i++)
    {
	to = torow;
	from = fromcol;
	for (j=0; j<in_height; j++)
	{
	    *to = *from;
	    to += 1;
	    from += in_lda;
	}
	fromcol++;
	torow += res_lda;
    }
}

#endif
