/*
   $Header: /u/spert/src/intvec/testsuite/RCS/scalar_i16_i16_test.c,v 1.1 1996/01/04 23:26:34 davidj Exp $

   Test scalar 16 bit unary ops
*/

#include <stddef.h>
#include <stdlib.h>

#include "intvec_test.h"

typedef intv_int16_t (*rtn_i16_i16_t)(intv_int16_t in);

void
multitest(rtn_i16_i16_t rtn, size_t len, const intv_int16_t* inv,
	  const intv_int16_t* corv)
{
    size_t i;
    intv_int16_t in;
    intv_int16_t res;
    intv_int16_t correct;

    for (i=0; i<len; i++)
    {
	in = *inv++;
	correct = *corv++;
	res = rtn(in);
	if (res!=correct)
	{
	    rtst_failed("in=%i res=%i correct=%i", in, res, correct);
	}
    }
}

void
test_swapb()
{
    const intv_int16_t in[] =
    {
	0, 0x1234, 0xfedc
    };
    const intv_int16_t res[] =
    {
	0, 0x3412, 0xdcfe
    };
    rtst_start("swapb_i16_i16");
    multitest(swapb_i16_i16, sizeof(in)/sizeof(in[0]), in, res);
    rtst_passed();
}



int
main(int argc, char *argv[])
{
    rtst_args(argc, argv);

    test_swapb();
    rtst_exit();

    return 0;
}
