/*
** $Id: milli_vi32_vi32.S,v 1.1 1995/10/10 19:00:51 davidj Exp $
**
** General millicode wrapper for unary interger to integer function
**
** jhauser - september '94
** davidj - Thu Nov 17 21:28:10 1994 ( Modified for inclusion in library)
** davidj - pulled into intvec - Tue Oct 10 11:54:25 1995
*/

#include <tor/tordef.h>
#include "m_regdef.h"

/****************************************************************/

#ifdef DECL_tor_countlz_vi32_vi32
void tor_countlz_vi32_vi32(size_t len, const intv_int32_t* in,
                           intv_int32_t* res);
#endif

#ifdef DEFN_tor_countlz_vi32_vi32
#define RTNNAME tor_countlz_vi32_vi32
#define MILLINAME tor_countlz_gi32_gi32
#endif

/****************************************************************/

/* This routine requires 2 macros defines
**
** RTNNAME - the name this routine will be known by
** MILLINAME - the name of the millicode routine it calls
*/ 

#ifndef RTNNAME
	.error
#endif
#ifndef MILLINAME
	.error
#endif

	.globl RTNNAME

	.extern MILLINAME

#define length a0		/* Vector length			*/
#define aPtr a1			/* Pointer to input vector in memory	*/
#define zPtr a2			/* Pointer to output vector in memory	*/

#define savedRA t0
#define autoincrement t1
#define done t2
#define maxvlr t3



	.ent RTNNAME
RTNNAME:
 # Check the length - jump forward if > 32

        .set    noreorder
        bgtu    length, MAXVLEN, longVector
        ctvu    length, vlr              # Assume len <= 32
        .set    reorder

 # The short case (len<32) follows directly for better cache performance

	lw.v va0,aPtr
	move savedRA, ra
	jal MILLINAME
	sw.v vz0,zPtr
	j savedRA

longVector:
	li maxvlr,MAXVLEN
	ctvu maxvlr,vlr
	li autoincrement,(4*MAXVLEN)
	lwai.v va0,aPtr,autoincrement
	move savedRA, ra
stripLoop:
	jal MILLINAME
	lwai.v va0,aPtr,autoincrement
	subu length, MAXVLEN
        sltu done, length ,MAXVLEN+1
	swai.v vz0,zPtr,autoincrement
	beqz done, stripLoop

	ctvu length,vlr
	jal MILLINAME
	sw.v vz0,zPtr
	j savedRA

	.end RTNNAME

