// $Header: /n/lasagna/db/davidj/spert/src/quicknet/H-spert0/../RCS/QN_SentDB_Subset.cc,v 1.3 1996/03/01 03:37:40 davidj Exp $

#include <QN_config.h>
#include <assert.h>
#include "QN_types.h"
#include "QN_Logger.h"
#include "QN_SentDB_Subset.h"


// The name of this class

const char* QN_SentDB_Subset::CLASSNAME = "QN_SentDB_Subset";


// Constructor.

QN_SentDB_Subset::QN_SentDB_Subset(int dbg, QN_SentDB& a_db, size_t first,
				   size_t num)
  : debug(dbg),
    db (a_db),
    first_sent(first),
    n_sentences(num>a_db.num_sentences() ? a_db.num_sentences() : num)
{
    n_frames = db.num_frames_in_sents(first_sent, n_sentences);
    if (debug>=1)
    {
	QN_LOG(CLASSNAME, "Using sentences %lu to %lu, total %lu frames.",
	       (unsigned long) first_sent,
	       (unsigned long) first_sent+n_sentences-1,
	       (unsigned long) n_frames);
    }
}

size_t
QN_SentDB_Subset::get_sentences(size_t sentno, size_t num_sents, 
				  QNUInt32* sentnos, QNUInt32* framenos,
				  float* ftrs, QNUInt32* labs, float* tgts)
{
    size_t frames;

    assert(sentno < n_sentences && (sentno+num_sents-1) < n_sentences);
    frames = db.get_sentences(first_sent + sentno, num_sents,
			      sentnos, framenos, ftrs, labs, tgts);
    if (debug>=3)
    {
	QN_LOG(CLASSNAME, "Read sentences %lu to %lu, %lu frames.",
	       (unsigned long) sentno,
	       (unsigned long) (sentno+num_sents-1),
	       (unsigned long) frames);
    }
    return frames;
}

