. $Header: /u/davidj/spert/src/quicknet/RCS/qnforward.man,v 1.19 1997/06/27 00:50:30 davidj Exp $
.TH qnforward 1 "$Date: 1997/06/27 00:50:30 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
qnforward \- simple MLP forward pass program using the QuickNet library
.SH SYNOPSIS
.B qnforward
[
.I options
]
.SH DESCRIPTION
.I qnforward
is a simple program for running MLPs (Multi Layer Perceptrons - a.k.a.
Neural Nets).  It implements a subset of the functionality of
\fBqnsfwd\fR and is only maintained for backwards compatability.  All
new recognition systems should use \fBqnsfwd\fR.
.SH OPTIONS
.I qnforward
can take the following options:
.TP 1i			\" Indent the paragraph
.BI input_weightfile= filename
Specify the file containing the weights for the net.  By default,
the format of this file is a RAP style weights file \- see
.BR weights (5).
.TP
.BI ftrfile= filename
Specify the file containing features to be passed through the net.
.TP
.BI ftrfile_format= format
Specify the format of the feature file.  This can be either
.B pfile
(the ICSI feature file format - see
.BR pfile (5))
or
.B pre
- the CUED feature file format.  The default is
.BR pfile .
.TP
.BI ftrfile_num_ftrs= integer
Specify the number of features in the feature file.  The default \- 
.B 0
\- means use the number of features specified in the feature file header.
A non-zero value must be given for feature files that are in a format
that does not include a header, e.g. Cambridge \fBpre\fR files.
.TP
.BI input_normfile= filename
Specify a file containing normalization parameters for the input
feature stream.  The default value \-
an empty string \- means apply no normalization.  In general, training
without normalization is not recommended.
.TP
.BI first_sent= integer
The number of the first sentence in the feature file to use
.RB ( 0
means use the first sentence in the feature file).
.TP
.BI num_sents= integer
The total number of sentences in the feature file to use.  Specifying
more than the available number of sentences will result in the rest of
the sentences being used, which is the default.
.TP
.BI first_ftr= integer
The first feature to use from the feature file.  This is often
.BR 1 ,
which ignores the energy feature in a typical PLP feature file.
.TP
.BI num_ftrs= integer
The number of features to use from the feature file.  The default \- \fB0\fR
\- means use all features in the feature file after the first feature
specified by the \fBfirst_ftr\fR option.
.TP
.BI window_width= integer
The number of frames of input features to combine to form the input layer
of the MLP.
.TP
.BI window_offset= integer
The offset of the start of the MLP input window from the current frame
being trained.  For example, with a
.B window_width
of
.B 9
, a
.B window_offset
of
.B -4
will result in a symmetric input window.
.TP
.BI num_input= integer
Number of input units in the MLP.
.TP
.BI num_hidden= integer
Number of hidden units in the MLP.
.TP
.BI num_output= integer
Number of output units in the MLP.
.TP
.BI mlp_output_type= unittype
Specify the type of non-linearity to use for the MLP output layer.
Allowable values are \fBsigmoid\fR, \fBsigmoidx\fR (same as \fBsigmoid\fR)
and \fBsoftmax\fR (the default).
.TP
.BI use_fx= bool
Use a fixed point MLP if
.BR true .
.TP
.BI mlp_weightexp= integer
Set the fixed point exponent of all weight (but not bias) matrices.
.TP
.BI output_file= filename
The file in which to store the resulting activation outputs.  Specifying a
filename of
.B \-
sends the results to standard output.
.TP
.BI output_file_format= format
The format used for outputting the results.  This can be one of
.BR rapascii ,
.BR raphex ,
.BR rapbin ,
or
.BR lna8 .
The default is
.BR rapascii ,
the ASCII phoneme probability format used by the RAP.
.TP
.BI verbose= bool
Output more status messages if
.BR true .
.TP
.BI debug= integer
Set the level of internal debugging output.  \fB0\fR means none,
\fB6\fR means lots!

.SH ENVIRONMENT
Describe the environment variables used here.
.TP 20
.B TZ
Time Zone.  On some systems, this is used for displaying times during
the run \- if times seem to be wrong by several hours, it is
because this environment variable is not set.

. .SH FILES

.SH AUTHOR
David Johnson  <davidj@ICSI.Berkeley.EDU>
.SH SEE ALSO
.BR qnsfwd (1) ,
.BR qntrain (1) ,
.BR qnnorm (1) ,
.BR lna (5) ,
.BR norms (5) ,
.BR pfile (5) ,
.BR weights (5) .
.SH NOTES
Many more options need to be added to this program.
.SH BUGS
Older versions of the SPERT libraries and servers do not support TZ \-
if all times are in GMT, upgrade to the latest SPERT development
environment and recompile Quicknet.
