#ifndef NO_RCSID
char* random_rcsid = "$Header: /u/drspeech/src/utils/randlines/RCS/random.c,v 1.5 1996/09/03 21:02:16 davidj Exp $";
#endif

#include <math.h>
#include <stdlib.h>
#include <time.h>

/* Written by Gary Tajchman  5/20/92 */

#ifdef VAX
#define srand48 srand
#define lrand48 rand
#endif


/*
  generate uniformly distributed random numbers between 0 and 0.9999
  */
float
frandom1()
{     
  float randy;
  
  randy = lrand48 () / 2147483648.0;
  return (randy);
}

/*
  generate uniformly distributed random numbers between -0.5 and +0.5
  */
float
frandom2()
{
  float randy;
  
  randy = lrand48 () / 2147483647.0 - 0.5;
  return (randy);
}

/*
  generate uniformly distributed random numbers between -1.0 and +1.0
  */
float
frandom3()
{
  float randy;
  
  randy = lrand48 () / 1073741823.0 - 1.0;
  return (randy);
}


int
intrand(int lower, int upper)
{
  int randy;
  
  randy = (upper - lower + 1) * frandom1 () + lower;
  return (randy);
}

int
rseed(int seed)
{
  if (seed == 0) {
    srand48(time (0) - 512413300);
    seed = intrand(1, 10000);
  }
  srand48(seed);
  return(seed);
}

/*
  generate normally distributed random numbers with mean 0 and standard
  deviation, 1.0. Uses algorithm P from Knuth's book.
  */
     
float
normal()
     
{
  float V1, V2;
  float S;
  float X1;
  
  do {
    V1 = 2.0 * frandom1 () - 1;
    V2 = 2.0 * frandom1 () -1;
    S = pow (V1, 2.0) + pow (V2, 2.0);
  } while (S >= 1.0);
  
  X1 = V1 * sqrt (-2.0 * log(S) / S);
  
  return (X1);
}


/* 
   generate a normalized random vector of size, dimension. Use the random 
   generator function passed as 'generator' to generate the random numbers.
   */
void
vrandom(float* vector, int dimension, float (*generator)())
{
  int i;
  
  for (i = 0; i < dimension; i++)
    vector[i] = (*generator) (); 
  normalize (vector, vector, dimension);
  
}

void
permute(int *vec, int dim)
{
  int i,j;
  int randnum;
  int temp;
  
  for (i=0; i < dim; i++)
    vec[i] = i;
  
  for (i=0; i < dim-1; i++) {
    j = dim-1 - i;
    randnum = intrand(0, j-1);
    temp = vec[j];
    vec[j] = vec[randnum];
    vec[randnum] = temp;
  }	
}
